
Installer - Bug #4357

Use of Puppet::Node::Environment.current in template headers breaks on Puppet 3.5/master

02/17/2014 12:48 PM - Dominic Cleal

Status: Closed   

Priority: High   

Assignee:    

Category: Foreman modules   

Target version: 1.5.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

e.g. /usr/share/foreman-installer/modules/foreman/templates/_header.erb

module_paths = Puppet::Node::Environment.current[:modulepath].split(':').map{|i| File.expand_path(

i) }.join('|')

 Produces this error:

[ERROR 2014-02-17 12:45:01 main]  Failed to parse template foreman/settings.yaml.erb:

[ INFO 2014-02-17 12:45:01 main]   Filepath: (erb)

[ INFO 2014-02-17 12:45:01 main]   Line: 4

[ INFO 2014-02-17 12:45:01 main]   Detail: undefined method `current' for Puppet::Node::Environmen

t:Class

[ INFO 2014-02-17 12:45:01 main]  at /usr/share/foreman-installer/modules/foreman/manifests/config

.pp:8 on node foreman-el6.example.com

 Affected paths:

/usr/share/foreman-installer/modules/foreman/templates/_header.erb

/usr/share/foreman-installer/modules/foreman_proxy/templates/settings.yml.erb

/usr/share/foreman-installer/modules/puppet/templates/_header.erb

/usr/share/foreman-installer/modules/puppet/templates/agent/puppet.conf.erb

/usr/share/foreman-installer/modules/puppet/templates/server/config.ru.erb

/usr/share/foreman-installer/modules/puppet/templates/server/puppet.conf.erb

Related issues:

Blocks Installer - Tracker #4359: Puppet 3.5.0 support Closed 02/17/2014 02/28/2014

Associated revisions

Revision c8e1f3b6 - 03/06/2014 10:27 AM - Dmitri Dolguikh 

fixes #4357: Removed template source from the header

Revision 67b71374 - 03/06/2014 02:56 PM - Dmitri Dolguikh 

fixes #4357: Removed template source from the header

Revision 13d061e6 - 03/06/2014 03:08 PM - Dmitri Dolguikh 

fixes #4357: Removed template source from the header

History

#1 - 02/17/2014 12:52 PM - Dominic Cleal

- Description updated

#2 - 02/17/2014 01:11 PM - Dominic Cleal

- Blocks Tracker #4359: Puppet 3.5.0 support added
#3 - 02/17/2014 02:26 PM - Dominic Cleal

Puppet::Context.lookup(:current_environment) appears to be the way to get the current environment from 3.5.0 onwards.

If we want to keep these headers, that is.

#4 - 02/17/2014 02:28 PM - Dominic Cleal

- Due date set to 02/28/2014

- translation missing: en.field_release set to 7

#5 - 02/25/2014 02:36 PM - Ewoud Kohl van Wijngaarden

Does that also work on puppet 2.7? If not, I don't mind dropping the headers.

#6 - 02/25/2014 02:41 PM - Dominic Cleal

Ewoud Kohl van Wijngaarden wrote:

Does that also work on puppet 2.7? If not, I don't mind dropping the headers.

 No, we'd need to check if the new method is available and fall back otherwise.  For example: 

https://github.com/theforeman/kafo/blob/v0.3.16/lib/kafo/validator.rb#L73-L75

I've had a change committed to Puppet master to keep the existing method, but it prints a deprecation warning, so we should still change.

#7 - 03/03/2014 01:29 PM - Dominic Cleal

- Target version set to 1.9.0

#8 - 03/06/2014 12:43 PM - Anonymous

- Status changed from New to Assigned

- Assignee set to Anonymous

#9 - 03/06/2014 03:00 PM - Anonymous

- Status changed from Assigned to Ready For Testing

PR: https://github.com/theforeman/puppet-puppet/pull/141

PR: https://github.com/theforeman/puppet-foreman/pull/163

#10 - 03/06/2014 03:09 PM - Anonymous

Missed one module. PR: https://github.com/theforeman/puppet-foreman_proxy/pull/94

#11 - 03/06/2014 03:50 PM - Anonymous

- Status changed from Ready For Testing to Closed

#12 - 03/10/2014 02:48 PM - Dominic Cleal

- translation missing: en.field_release changed from 7 to 4

There's now a deprecated compatibility method in Puppet so the installer continues to work, will release instead in 1.5.
